Autodesk.Revit.Creation.eRefFace是Revit中的一个枚举类型,在创建Revit元素时使用。该类型表示对一个引用面的引用,该面由Revit中的其他元素定义。这些元素包括但不限于墙壁,地板,天花板和房间边界。
None:没有引用面。
Bottom:底部引用面。通常用于描述门、窗和墙体中底部的开口。
Top:顶部引用面。通常用于描述门、窗和墙体中顶部的开口。
Front:前面引用面。通常用于描述门、窗和墙体中位于z轴正方向的端口。
Back:后面引用面。通常用于描述门、窗和墙体中位于z轴负方向的端口。
Left:左边引用面。通常用于描述门、窗和墙壁中位于x轴负方向的端口。
Right:右侧引用面。通常用于描述门、窗和墙壁中位于x轴正方向的端口。
在创建Revit元素时,通常需要指定一个或多个引用面的类型。通过将创建属性设置为Autodesk.Revit.Creation.eReferenceType.Face和指定特定的eRefFace枚举值,可以指示Revit应该如何在元素中使用该引用面。
例如,以下代码片段创建一个长方体,其中底部引用面始终位于x轴的原点,顶部引用面始终位于(x = 0, y = 10, z = 0)的点,并且长方体的其余面相对于这些点的值在每次调用时均为随机值:
using Autodesk.Revit.Creation;
// Create a new Rectangle object
Rectangle rect = new Rectangle(
new Point(0, 0),
new Point(10, 10)
);
// Create a new reference plane at the origin
ReferencePlane bottomRefererencePlane = Document.Create.NewReferencePlane(
new Point(0, 0, 0),
new XYZ(1, 0, 0),
new XYZ(0, 0, 1)
);
// Create another reference plane offset from the first one
XYZ topReferencePlaneOrigin = new XYZ(0, 10, 0);
ReferencePlane topReferencePlane = Document.Create.NewReferencePlane(
topReferencePlaneOrigin,
new XYZ(1, 0, 0),
new XYZ(0, 0, 1)
);
// Create a new rectangle extrusion using the reference planes
XYZ zDirection = new XYZ(0, 0, 1);
SketchPlane sketchPlane = SketchPlane.Create(Document, bottomReferencePlane);
Plane plane = Plane.CreateByNormalAndOrigin(zDirection, new XYZ(0, 0, 0));
Extrusion extrusion = Document.Create.NewExtrusion(rect, plane, 10, SketchPlane);
extrusion.AddReferences(topReferencePlane, ReferenceType.Top);